/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.commonfortool.view.filechooser;

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class HtmlSaveFileChooser {

	private final JFileChooser fileChooser;// NOPMD

	private final JFrame frame;// NOPMD

	public HtmlSaveFileChooser(final JFrame frame, final String title,
			final String currentDirectoryPath) {
		this.frame = frame;
		fileChooser = new JFileChooser(currentDirectoryPath);
		fileChooser.setDialogTitle(title);
		fileChooser.setFileFilter(new HtmlFileFilter());
		fileChooser.setAcceptAllFileFilterUsed(false);
		fileChooser.setDialogType(JFileChooser.SAVE_DIALOG);
	}

	public boolean approve() {
		final int choice = fileChooser.showSaveDialog(frame);
		return choice == JFileChooser.APPROVE_OPTION;
	}

	public File getSelectedFile() {
		File selectedFile = fileChooser.getSelectedFile();
		final String absolutePath = selectedFile.getAbsolutePath();
		final String lowerCase = absolutePath.toLowerCase();// NOPMD
		if (!lowerCase.endsWith(".htm") && !lowerCase.endsWith(".html")) {
			selectedFile = new File(absolutePath + ".html");
		}
		return selectedFile;
	}

}
