/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.commonfortool.view.filechooser;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * xml file filter for {@link javax.swing.JFileChooser}
 * 
 * @author luc peuvrier
 * 
 */
public class XmlFileFilter extends FileFilter {

	@Override
	public boolean accept(final File file) {
		final boolean accept;
		if (file.isDirectory()) {
			accept = true;
		} else if (file.isFile()) {
			accept = file.getName().toLowerCase().endsWith(".xml");
		} else {
			accept = false;
		}
		return accept;
	}

	@Override
	public String getDescription() {
		return "XML file";
	}
}
