/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parse4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generator.entity.grammardefnode;

import java.util.LinkedList;
import java.util.List;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class CharListDef extends AbstractGrammarDefNodeNotVisitable {

	private final List<Character> charList = new LinkedList<Character>();// NOPMD

	public CharListDef(final List<Character> charList, final char terminalValue) {
		super();
		this.charList.addAll(charList);
		this.charList.add(terminalValue);
	}

	public CharListDef(final char terminalValue) {
		super();
		charList.add(terminalValue);
	}

	public List<Character> getCharList() {
		return charList;
	}
}
