package net.sf.parser4j.generator.entity.grammardefnode;

public enum EnumStatementDefType {

	/**
	 * alternative
	 */
	ALTERNATIVE(false),
	/**
	 * concatenation
	 */
	CONCAT(false),
	/**
	 * empty
	 */
	EMPTY(true),
	/**
	 * non terminal
	 */
	NON_TERMINAL(false),
	/**
	 * terminal string
	 */
	TERMINAL_STRING(true),
	/**
	 * terminal char
	 */
	TERMINAL_CHAR(true),
	/**
	 * terminal set of terminal
	 */
	TERMINAL_SET_OF_TERMINAL(true),
	/**
	 * terminal char range
	 */
	TERMINAL_CHAR_RANGE(true),
	/**
	 * terminal char set
	 */
	TERMINAL_CHAR_SET(true);

	private final boolean terminal;

	private EnumStatementDefType(final boolean terminal) {
		this.terminal = terminal;
	}

	public boolean isTerminal() {
		return terminal;
	}

	public boolean isNonTerminalDef() {
		return NON_TERMINAL.equals(this);
	}

	public boolean isEmptyDef() {
		return EMPTY.equals(this);
	}
}
