/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generator.entity.grammardefnode;

import net.sf.parser4j.generator.service.GrammarDefNodeVisitException;
import net.sf.parser4j.generator.service.grammardefnode.IGrammarDefVisitor;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class RuleDef implements IGrammarDefNode {

	private final String nonTerminalDefinedName;// NOPMD

	private final StatementDef statementDef;// NOPMD

	private final boolean token; // NOPMD

	public RuleDef(final String identifierDefined,
			final StatementDef statementDef, final boolean token) {
		this.nonTerminalDefinedName = identifierDefined;
		this.statementDef = statementDef;
		this.token = token;
	}

	public String getNonTerminalDefinedName() {
		return nonTerminalDefinedName;
	}

	public StatementDef getStatementDef() {
		return statementDef;
	}

	public boolean isToken() {
		return token;
	}

	public void accept(final IGrammarDefVisitor visitor)
			throws GrammarDefNodeVisitException {
		visitor.beginVisit(this);
		statementDef.accept(visitor);
		visitor.endVisit(this);
	}

	@Override
	public String toString() {
		final StringBuilder stringBuilder = new StringBuilder();
		stringBuilder.append("RuleDef, non terminal defined: ");
		stringBuilder.append(nonTerminalDefinedName);
		stringBuilder.append(", is token: ");
		stringBuilder.append(token);
		return stringBuilder.toString();
	}
}
