/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generator.entity.parserdata;

import net.sf.parser4j.kernelgenerator.service.GeneratorException;
import net.sf.parser4j.parser.entity.data.ParserData;
import net.sf.parser4j.parser.service.ParserException;
import net.sf.parser4j.parser.service.data.ParserDataIO;

/**
 * to read parser data for parser generator from its resource file
 * 
 * @author luc peuvrier
 * 
 */
public final class ParserDataForGeneratorInput {

	private static final ParserDataIO parserDataIO = ParserDataIO.getInstance();

	public static final String PARSER_DATA_FILE_NAME = "gen_parser.data";

	private static final ParserDataForGeneratorInput INSTANCE =
	/**/new ParserDataForGeneratorInput();

	public static ParserDataForGeneratorInput getInstance() {
		return INSTANCE;
	}

	private ParserDataForGeneratorInput() {
		super();
	}

	public ParserData read() throws GeneratorException {
		try {
			return parserDataIO.readFromClassPackage(getClass(),
					PARSER_DATA_FILE_NAME);
		} catch (ParserException exception) {
			throw new GeneratorException(exception);
		}
	}
}
