/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generator.service.match;

import net.sf.parser4j.generator.entity.grammardefnode.StatementDef;
import net.sf.parser4j.parser.entity.IParseSessionForMatchMgr;
import net.sf.parser4j.parser.entity.parsenode.IParseNode;
import net.sf.parser4j.parser.service.match.AbstractMatchMgrAdapter;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class MatchCharFromHexa extends AbstractMatchMgrAdapter {

	@Override
	public void reduceAction(final IParseSessionForMatchMgr parseSession,
			final IParseNode fatherParseNode, final IParseNode[] parseNodes,
			final int[] notWhiteIndexes) {
		final char digit1 = (char) ((StatementDef) parseNodes[notWhiteIndexes[2]]
				.getUniqData()).getTerminalCharValue();
		final char digit2 = (char) ((StatementDef) parseNodes[notWhiteIndexes[3]]
				.getUniqData()).getTerminalCharValue();
		final StringBuilder builder = new StringBuilder(2);
		builder.append(digit1);
		builder.append(digit2);
		final char terminalValue = (char) Integer.parseInt(builder.toString(),
				16);
		fatherParseNode.setData(new StatementDef(terminalValue));
	}
}
