/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generator.service.match;

import net.sf.parser4j.generator.entity.grammardefnode.RuleDef;
import net.sf.parser4j.generator.entity.grammardefnode.RulesDef;
import net.sf.parser4j.kernelgenerator.service.GeneratorException;
import net.sf.parser4j.kernelgenerator.service.GeneratorRuntimeException;
import net.sf.parser4j.parser.entity.IParseSessionForMatchMgr;
import net.sf.parser4j.parser.entity.parsenode.IParseNode;
import net.sf.parser4j.parser.entity.parsenode.data.IParseNodeData;
import net.sf.parser4j.parser.service.match.AbstractMatchMgrAdapter;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class MatchRules extends AbstractMatchMgrAdapter {

	@Override
	public void reduceAction(final IParseSessionForMatchMgr parseSession,
			final IParseNode fatherParseNode, final IParseNode[] parseNodes,
			final int[] notWhiteIndexes) {
		final IParseNode parseNode = parseNodes[notWhiteIndexes[0]];
		final IParseNodeData parseNodeDef = parseNode.getUniqData();
		final RulesDef rulesDef;
		final Class<? extends IParseNodeData> parseNodeDefClass = parseNodeDef
				.getClass();

		if (parseNodeDefClass == RuleDef.class) {
			try {
				rulesDef = new RulesDef((RuleDef) parseNodeDef);
			} catch (GeneratorException exception) {
				throw new GeneratorRuntimeException(exception);
			}
		} else if (parseNodeDefClass == RulesDef.class) {
			rulesDef = (RulesDef) parseNodeDef;
		} else {
			throw new IllegalArgumentException("bad class " + parseNodeDefClass);
		}
		fatherParseNode.setData(rulesDef);
	}
}
