/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.kernelgenerator.entity;

import net.sf.parser4j.kernelgenerator.entity.grammarnode.IGrammarNode;
import net.sf.parser4j.parser.entity.data.NonTerminalMap;

/**
 * grammar tree data: it is {@link IGrammarNode} grammar root node and
 * {@link NonTerminalMap}
 * 
 * @author luc peuvrier
 * 
 */
public class GrammarTreeFactoryData {

	private final NonTerminalMap nonTerminalMap;// NOPMD

	private final IGrammarNode rootGrammarNode;// NOPMD

	public GrammarTreeFactoryData(final NonTerminalMap nonTerminalMap,
			final IGrammarNode rootGrammarNode) {
		super();
		this.nonTerminalMap = nonTerminalMap;
		this.rootGrammarNode = rootGrammarNode;
	}

	public NonTerminalMap getNonTerminalMap() {
		return nonTerminalMap;
	}

	public IGrammarNode getRootGrammarNode() {
		return rootGrammarNode;
	}
}
