/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.kernelgenerator.entity;

import java.util.Set;
import java.util.TreeSet;

import net.sf.parser4j.parser.entity.data.TerminalCharRange;

/**
 * set of {@link RecognitionPoint} for a {@link TerminalCharRange}
 * 
 * @author luc peuvrier
 * 
 */
public class RecognitionPointForTerminalRange {

	private final TerminalCharRange terminalCharRange;// NOPMD

	private final Set<RecognitionPoint> setOfRecognitionPoint = // NOPMD
	/**/new TreeSet<RecognitionPoint>();

	public RecognitionPointForTerminalRange(
			final TerminalCharRange terminalCharRange) {
		super();
		this.terminalCharRange = terminalCharRange;
	}

	public void addRecognitionPoint(final RecognitionPoint recognitionPoint) {
		if (recognitionPoint == null) {
			throw new IllegalArgumentException(
					"recognition point is null but must be defined");
		}
		setOfRecognitionPoint.add(recognitionPoint);
	}

	public int getFirstTerminalValue() {
		return terminalCharRange.getFirstTerminalValue();
	}

	public int getLastTerminalValue() {
		return terminalCharRange.getLastTerminalValue();
	}

	public Set<RecognitionPoint> getSetOfRecognitionPoint() {
		return setOfRecognitionPoint;
	}

	public TerminalCharRange getTerminalCharRange() {
		return terminalCharRange;
	}
}
