/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.kernelgenerator.entity.grammarnode.impl;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.InitializingBean;

import net.sf.parser4j.parser.entity.data.NonTerminalMap;

/**
 * extends {@link GrammarNodeConcat} for spring setup
 * 
 * @author luc peuvrier
 * 
 */
public class GrammarNodeConcatSpringBean extends GrammarNodeConcat implements
		InitializingBean, IGrammarNodeSpringBean {

	private static final Logger _log = Logger
			.getLogger(GrammarNodeConcatSpringBean.class);

	private NonTerminalMap nonTerminalMap;// NOPMD

	public void setNonTerminalMap(final NonTerminalMap nonTerminalMap) {
		this.nonTerminalMap = nonTerminalMap;
	}

	public void afterPropertiesSet() throws Exception {// NOPMD
		final int nonTerminalIdentifier = nonTerminalMap
				.createNonTerminalIdentifier(nonTerminalName,
						matchClassSimpleName, isToken());
		setNonTerminalIdentifier(nonTerminalIdentifier);
		super.setNonTerminalName(nonTerminalMap.nonTerminalName(
				nonTerminalIdentifier).getName());
		if (_log.isDebugEnabled()) {
			_log.debug(toString());
		}
	}
}
