/*
 * Copyright 2009 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.kernelgenerator.entity.grammarnode.impl;

import net.sf.parser4j.kernelgenerator.entity.grammarnode.IGrammarNode;
import net.sf.parser4j.kernelgenerator.service.GrammarNodeVisitException;
import net.sf.parser4j.kernelgenerator.service.grammarnode.IGrammarNodeVisitor;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class OperandGrammarNode {

	private IGrammarNode grammarNode;

	private boolean whiteSpace = false;

	public IGrammarNode getGrammarNode() {
		return grammarNode;
	}

	public void setGrammarNode(final IGrammarNode grammarNode) {
		this.grammarNode = grammarNode;
	}

	public boolean isWhiteSpace() {
		return whiteSpace;
	}

	public void setWhiteSpace(final boolean whiteSpace) {
		this.whiteSpace = whiteSpace;
	}

	public boolean isToken() {
		return grammarNode.isToken();
	}

	public int getNonTerminalIdentifier() {
		return grammarNode.getNonTerminalIdentifier();
	}

	public String getNonTerminalName() {
		return grammarNode.getNonTerminalName();
	}

	public void accept(final IGrammarNodeVisitor grammarNodeVisitor)
			throws GrammarNodeVisitException {
		grammarNode.accept(grammarNodeVisitor);
	}

}
