/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.gen4gen.service;

import java.io.File;

import net.sf.parser4j.generator.entity.parserdata.ParserDataForGeneratorInput;
import net.sf.parser4j.generator.entity.parserdata.ParserDataPackageForParserGenerator;
import net.sf.parser4j.parser.entity.data.ParserData;
import net.sf.parser4j.parser.service.ParserException;
import net.sf.parser4j.parser.service.data.ParserDataIO;

/**
 * to write parser data for parser generator in its resource file
 * 
 * @author luc peuvrier
 * 
 */
public final class ParserDataOutputForGenerator {

	private static final ParserDataIO parserDataIO = ParserDataIO.getInstance();

	private static final ParserDataOutputForGenerator INSTANCE =
	/**/new ParserDataOutputForGenerator();

	public static ParserDataOutputForGenerator getInstance() {
		return INSTANCE;
	}

	private ParserDataOutputForGenerator() {
		super();
	}

	public void writeParserData(final ParserData parserData)
			throws ParserException {
		final String packageName = ParserDataPackageForParserGenerator
				.getPackageName();
		final String path = "src-gen/" + packageName.replace('.', '/') + "/"
				+ ParserDataForGeneratorInput.PARSER_DATA_FILE_NAME;
		parserDataIO.writeToFile(new File(path), parserData);
	}
}
