/*
 * Copyright 2009 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity;

import net.sf.parser4j.parser.service.ParserException;
import net.sf.parser4j.parser.service.ParserFileReader;

/**
 * view of parse session for match manager
 * 
 * @author luc peuvrier
 * 
 */
public interface IParseSessionForMatchMgr {

	String getParserInputFileName();

	void include(ParserFileReader parserFileReader) throws ParserException;

	/**
	 * remove all attribute
	 * 
	 * @see java.util.Map#clear()
	 */
	void removeAllAttribute();

	/**
	 * get attribute by its key
	 * 
	 * @param attributeKey
	 * @return attribute object
	 * @see java.util.Map#get(java.lang.Object)
	 */
	Object getAttribute(final String attributeKey);

	/**
	 * set attribute by its key
	 * 
	 * @param attributeKey
	 * @param attribute
	 * @return previous attribute for the key
	 * @see java.util.Map#put(java.lang.Object, java.lang.Object)
	 */
	Object setAttribute(final String attributeKey, final Object attribute);
}
