/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity.data;

import java.io.Serializable;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

/**
 * goto table entry for non terminal: to state by non terminal map<br>
 * 
 * @author luc peuvrier
 * 
 */
public class GotoByNonTerminalEntry implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8677674439583923247L;

	/** to state (value) by non terminal identifier (key) map */
	private final Map<Integer, ToStateAndWhiteSpaceFlag> gotoMap = // NOPMD
	/**/new TreeMap<Integer, ToStateAndWhiteSpaceFlag>();

	// /**
	// * add a goto state by non terminal
	// *
	// * @param nonTerminalIdentifier
	// * @param toStateIdentifier
	// */
	// public void addGoto(final int nonTerminalIdentifier,
	// final boolean nonTerminalAsWhiteSpace, final int toStateIdentifier) {
	// final ToStateAndWhiteSpaceFlag toStateAndWhiteSpaceFlag =
	// /**/new ToStateAndWhiteSpaceFlag(toStateIdentifier,
	// nonTerminalAsWhiteSpace);
	// gotoMap.put(nonTerminalIdentifier, toStateAndWhiteSpaceFlag);
	// }

	/**
	 * add a goto state by non terminal
	 * 
	 * @param nonTerminalIdentifier
	 * @param toStateAndWhiteSpaceFlag
	 */
	public void addGoto(final int nonTerminalIdentifier,
			final ToStateAndWhiteSpaceFlag toStateAndWhiteSpaceFlag) {
		gotoMap.put(nonTerminalIdentifier, toStateAndWhiteSpaceFlag);
	}

	// /**
	// *
	// * @param nonTerminalIdentifier
	// * @return to state by non terminal, -1 if no transition
	// */
	// public int toState(final int nonTerminalIdentifier) {
	// final ToStateAndWhiteSpaceFlag toStateAndWhiteSpaceFlag = gotoMap
	// .get(nonTerminalIdentifier);
	// return toStateAndWhiteSpaceFlag == null ? -1 : toStateAndWhiteSpaceFlag
	// .getToState();
	// }

	/**
	 * 
	 * @param nonTerminalIdentifier
	 * @return to state and white space flag by non terminal, null if no
	 *         transition
	 */
	public ToStateAndWhiteSpaceFlag toStateAndWhiteSpaceFlag(
			final int nonTerminalIdentifier) {
		return gotoMap.get(nonTerminalIdentifier);
	}

	/**
	 * expected non terminal
	 * 
	 * @return set of non terminal identifier
	 */
	public Set<Integer> expected() {
		return gotoMap.keySet();
	}

	public Map<Integer, ToStateAndWhiteSpaceFlag> getGotoMap() {
		return gotoMap;
	}
}
