/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity.data;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

/**
 * set of identifier match informations
 * 
 * @author luc peuvrier
 * 
 */
public class MatchEntrySet implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7387168572473011227L;

	private final Set<MatchEntry> nonTerminalMatchSet = // NOPMD
	/**/new TreeSet<MatchEntry>();

	private final boolean token; // NOPMD

	public MatchEntrySet(final boolean token) {
		super();
		this.token = token;
	}

	public boolean isToken() {
		return token;
	}

	public void addMatch(final int nonTerminalIdentifier, final int length,
			final int nodeType, final boolean token) {
		final MatchEntry matchEntry = new MatchEntry(nonTerminalIdentifier,
				length, nodeType, token);
		nonTerminalMatchSet.add(matchEntry);
	}

	public boolean match() {
		return true ^ nonTerminalMatchSet.isEmpty();
	}

	public Iterator<MatchEntry> matchEntrySetIterator() {
		return nonTerminalMatchSet.iterator();
	}

	public Set<MatchEntry> getNonTerminalMatchSet() {
		return nonTerminalMatchSet;
	}
}
