/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity.data;

import java.io.Serializable;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class NonTerminal implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6138418136750531268L;

	private final int identifier;// NOPMD

	private final String name;// NOPMD

	private final boolean token;// NOPMD

	public NonTerminal(final int identifier, final String name,
			final boolean token) {
		super();
		this.identifier = identifier;
		this.name = name;
		this.token = token;
	}

	public int getIdentifier() {
		return identifier;
	}

	public String getName() {
		return name;
	}

	public boolean isToken() {
		return token;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return name + "( id=" + identifier + ", is token=" + token + ")";
	}

}
