/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity.data;

import java.io.Serializable;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class ToStateAndWhiteSpaceFlag implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1815040206910184985L;

	private final int toState;// NOPMD

	private final boolean whiteSpace;// NOPMD

	public ToStateAndWhiteSpaceFlag(final int toState, final boolean whiteSpace) {
		super();
		this.toState = toState;
		this.whiteSpace = whiteSpace;
	}

	public int getToState() {
		return toState;
	}

	public boolean isWhiteSpace() {
		return whiteSpace;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		final StringBuilder stringBuilder = new StringBuilder();
		stringBuilder.append(toState);
		if (whiteSpace) {
			stringBuilder.append(" (white space)");
		}
		return stringBuilder.toString();
	}
}
