/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity.parsenode;

import net.sf.parser4j.parser.entity.EnumNodeType;
import net.sf.parser4j.parser.service.parsenode.IParseNodeVisitor;

/**
 * empty parse node
 * 
 * @author luc peuvrier
 * 
 */
public class EmptyParseNode extends AbstractNonTerminalParseNode {

	public EmptyParseNode(final IParseNode[] parseNodes) {
		super(EnumNodeType.EMPTY, parseNodes);
	}

	@Override
	public void accept(final IParseNodeVisitor visitor) {
		if (visitor.beginVisit(this)) {
			visitor.endVisit(this);
		}
	}

	@Override
	public String toString() {
		return "empty\n";
	}
}
