/*
 * Copyright 2009 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity.parsenode.status.impl;

import net.sf.parser4j.parser.entity.parsenode.status.IParseNodeStatus;

/**
 * implementation of {@link IParseNodeStatus }
 * 
 * @author luc peuvrier
 * 
 */
public abstract class AbstractParseNodeStatus implements IParseNodeStatus {

	/** true if parse node is in error, false by default */
	private final boolean inError;// NOPMD

	public AbstractParseNodeStatus() {
		super();
		inError = false;
	}

	public AbstractParseNodeStatus(final boolean inError) {
		super();
		this.inError = inError;
	}

	/**
	 * @see net.sf.parser4j.parser.entity.parsenode.status.IParseNodeStatus#isInError()
	 */
	@Override
	public boolean isInError() {
		return inError;
	}

}
