/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.entity.parsestate;

import java.util.List;

import net.sf.parser4j.parser.service.HasAmbiguityParserException;
import net.sf.parser4j.parser.service.ParserException;

/**
 * specialization for lexical analysis
 * 
 * @author luc peuvrier
 * 
 */
public class LexParseState extends AbstractParseState {

	public LexParseState(final boolean acceptAmbiguity,
			final int maxNumberOfAlternative, final boolean[] tokenRecognition,
			final List<ParseStack> tokenRecognitionParseStackList)
			throws ParserException, HasAmbiguityParserException {
		super(acceptAmbiguity, maxNumberOfAlternative, tokenRecognition);
		for (ParseStack parseStack : tokenRecognitionParseStackList) {
			add(parseStack);
		}
	}

}
