/*
 * Copyright 2008 Luc Peuvrier
 * 
 * Licensed under the GNU LESSER GENERAL PUBLIC LICENSE
 * Licensed under the LGPL License, Version 3, 29 June 2007 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.sf.parser4j.parser.service;

import java.io.PrintWriter;
import java.io.StringWriter;

public final class DebugUtil {

	private static final String AT = "\tat ";// NOPMD

	private final static DebugUtil INSTANCE = new DebugUtil();

	private DebugUtil() {
		super();
	}

	public static DebugUtil getInstance() {
		return INSTANCE;
	}

	/**
	 * 
	 * @return the stack trace
	 */
	public String stackTrace() {
		final Exception exception = new Exception("stack trace");// NOPMD
		return stackTrace(exception);
	}

	/**
	 * 
	 * @param throwable
	 * @return the stack trace
	 */
	public String stackTrace(final Throwable throwable) {
		final String stackTrace;
		if (throwable == null) {
			stackTrace = "";
		} else {
			StringWriter writer = new StringWriter();
			PrintWriter printWriter = new PrintWriter(writer);
			throwable.printStackTrace(printWriter);
			stackTrace = writer.toString();
		}
		return stackTrace;
	}
}
