/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.service;

/**
 * {@link StringBuilder} extention
 * 
 * @author luc peuvrier
 * 
 */
public class ExStringBuilder {

	private final StringBuilder stringBuilder = new StringBuilder();// NOPMD

	public ExStringBuilder append(final String stringValue) {
		stringBuilder.append(stringValue);
		return this;
	}

	public StringBuilder append(final int intValue) {
		return stringBuilder.append(intValue);
	}

	public StringBuilder append(final char charValue) {
		return stringBuilder.append(charValue);
	}

	public ExStringBuilder appendTabulate(final int numberOfTab,
			final String stringValue) {
		final String[] lineList = stringValue.split("\n");
		for (String line : lineList) {
			for (int count = 0; count < numberOfTab; count++) {
				stringBuilder.append('\t');
			}
			stringBuilder.append(line);
			stringBuilder.append('\n');
		}
		return this;
	}

	public String toString() {
		return stringBuilder.toString();
	}

}
