/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.service;

import java.util.List;

import net.sf.parser4j.parser.entity.parsenode.IParseNode;

/**
 * throws when ambiguity detected and not accepted
 * 
 * @author luc peuvrier
 * 
 */
public class HasAmbiguityParserException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5344017996452109632L;

	/** with alternative parse node list */
	private List<IParseNode> withAlternativeParseNodeList;// NOPMD

	public HasAmbiguityParserException() {
		super();
	}

	public HasAmbiguityParserException(final String message,
			final Throwable cause) {
		super(message, cause);
	}

	public HasAmbiguityParserException(final String message) {
		super(message);
	}

	public HasAmbiguityParserException(final Throwable cause) {
		super(cause);
	}

	public HasAmbiguityParserException(final String message,
			final List<IParseNode> withAlternativeParseNodeList) {
		super(message);
		this.withAlternativeParseNodeList = withAlternativeParseNodeList;
	}

	/**
	 * 
	 * @return with alternative parse node list
	 */
	public List<IParseNode> getWithAlternativeParseNodeList() {
		return withAlternativeParseNodeList;
	}
}
