/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parse4j.
 *
 * parse4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parse4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with parse4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.service.parsenode;

import net.sf.parser4j.parser.entity.EnumNodeType;
import net.sf.parser4j.parser.entity.parsenode.IParseNode;
import net.sf.parser4j.parser.entity.parsenode.CharacterParseNode;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class CharacterParseNodeCreator implements IParseNodeCreator {

	private final static ParsingToStringUtil parsingToStringUtil =
	/**/ParsingToStringUtil.getInstance();

	@Override
	public IParseNode create(final IParseNode[] parseNodes) {
		if (parseNodes.length != 1) {
			throw new IllegalArgumentException(
					"must have one and only one son\n"
							+ parsingToStringUtil.parseNodesToString(
									parseNodes, true));
		}
		final IParseNode parseNode = parseNodes[0];
		final CharacterParseNode characterParseNode;
		if (EnumNodeType.CHARACTER_TERMINAL
				.equals(parseNode.getParseNodeType())) {
			characterParseNode = new CharacterParseNode(
					(CharacterParseNode) parseNode);
		} else {
			throw new IllegalArgumentException("son must be terminal and is "
					+ parseNode.getParseNodeType());
		}

		return characterParseNode;
	}
}
