/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parse4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.parser.service.parsenode;

import net.sf.parser4j.parser.entity.EnumNodeType;
import net.sf.parser4j.parser.entity.parsenode.IParseNode;
import net.sf.parser4j.parser.entity.parsenode.StringParseNode;
import net.sf.parser4j.parser.entity.parsenode.CharacterParseNode;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class StringParseNodeCreator implements IParseNodeCreator {

	@Override
	public IParseNode create(final IParseNode[] parseNodes) {
		final StringBuilder builder = new StringBuilder();
		for (IParseNode parseNode : parseNodes) {
			if (EnumNodeType.CHARACTER_TERMINAL.equals(parseNode
					.getParseNodeType())) {
				final CharacterParseNode characterParseNode = (CharacterParseNode) parseNode;
				builder.append((char) characterParseNode.getTerminalValue());
			} else {
				throw new IllegalArgumentException(
						"son must be terminal and is "
								+ parseNode.getParseNodeType());
			}
		}
		return new StringParseNode(builder.toString());
	}
}
