/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generateandparsetest.test;

import net.sf.parser4j.parser.entity.ParseResult;
import net.sf.parser4j.parser.service.HasAmbiguityParserException;
import net.sf.parser4j.parser.service.Parser;
import net.sf.parser4j.parser.service.ParserException;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class AlternativeGrammarTest extends AbstractGrammarTest {

	public void testAlternativeGrammar() throws ParserException,
			HasAmbiguityParserException {// NOPMD
		final String simpleSpringFileName = "alternative.xml";
		final Parser parser = createParser(simpleSpringFileName);
		/*
		 * parsing of "a"
		 */
		ParseResult result = parse(parser, false, false, "a");
		assertFalse("must have one result\n" + result, result.isInError());
		assertFalse("must not have alternative for ambiguity", parser
				.hasAlternativeForAmbiguity());
		String expected =
		/**/"begin ALTERNATIVE Start(65538)\n" +
		/**/" begin CHARACTER_TERMINAL ntA(65536) 'a'\n" +
		/**/" end ntA\n" +
		/**/"end Start\n";

		assertExpected(expected, result);

		/*
		 * parsing of "b"
		 */
		result = parse(parser, false, false, "b");
		assertFalse("must have one result\n" + result, result.isInError());
		expected =
		/**/"begin ALTERNATIVE Start(65538)\n" +
		/**/" begin CHARACTER_TERMINAL ntB(65537) 'b'\n" +
		/**/" end ntB\n" +
		/**/"end Start\n";

		assertExpected(expected, result);
	}
}
