/*
 * Copyright 2009 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generateandparsetest.test;

import net.sf.parser4j.parser.entity.ParseResult;
import net.sf.parser4j.parser.service.HasAmbiguityParserException;
import net.sf.parser4j.parser.service.Parser;
import net.sf.parser4j.parser.service.ParserException;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class Bug1GrammarTest extends AbstractGrammarTest {

	public void testBug1Grammar() throws ParserException,
			HasAmbiguityParserException {// NOPMD
		final String simpleSpringFileName = "bug1.xml";
		final Parser parser = createParser(simpleSpringFileName);
		/*
		 * parsing of " %"
		 */
		ParseResult result = parse(parser, false, false, " %");
		assertFalse("must have one result\n" + result, result.isInError());
		assertFalse("must not have alternative for ambiguity", parser
				.hasAlternativeForAmbiguity());
		String expected =
		/**/"begin ALTERNATIVE Start(65550)\n" +
		/**/" begin CONCAT Start_0(65540)\n" +
		/**/"  begin ALTERNATIVE ws (token)(65538)\n" +
		/**/"   begin CHARACTER_TERMINAL _space(65537) ' '\n" +
		/**/"   end _space\n" +
		/**/"  end ws (token)\n" +
		/**/"  begin CHARACTER_TERMINAL percent(65539) '%'\n" +
		/**/"  end percent\n" +
		/**/" end Start_0\n" +
		/**/"end Start\n";

		assertExpected(expected, result);

		/*
		 * parsing of " include"
		 */
		result = parse(parser, false, false, " include");
		assertFalse("must have one result\n" + result, result.isInError());
		expected =
		/**/"begin ALTERNATIVE Start(65550)\n" +
		/**/" begin CONCAT Start_1(65549)\n" +
		/**/"  begin ALTERNATIVE ws (token)(65538)\n" +
		/**/"   begin CHARACTER_TERMINAL _space(65537) ' '\n" +
		/**/"   end _space\n" +
		/**/"  end ws (token)\n" +
		/**/"  begin STRING_TERMINAL include (token)(65541) include\n" +
		/**/"  end include (token)\n" +
		/**/" end Start_1\n" +
		/**/"end Start\n";

		assertExpected(expected, result);
	}
}
