/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generateandparsetest.test;

import net.sf.parser4j.parser.entity.ParseResult;
import net.sf.parser4j.parser.service.HasAmbiguityParserException;
import net.sf.parser4j.parser.service.Parser;
import net.sf.parser4j.parser.service.ParserException;

/**
 * 
 * @author luc peuvrier
 * 
 */
public class ListTest extends AbstractGrammarTest {

	public void testListGrammar() throws ParserException,
			HasAmbiguityParserException {// NOPMD
		final Parser parser = createParser("list.xml");
		/*
		 * parsing of "a"
		 */
		final ParseResult result = parse(parser, false, false, "a");
		assertFalse("must have one result\n" + result, result.isInError());
		assertFalse("must not have alternative for ambiguity", parser
				.hasAlternativeForAmbiguity());

		final String expected =
		/**/"begin CONCAT Start(65543)\n" +
		/**/" begin ALTERNATIVE List(65542)\n" +
		/**/"  begin CONCAT Elt(65540)\n" +
		/**/"   begin ALTERNATIVE ws(65538)\n" +
		/**/"    begin EMPTY Empty(65536)\n" +
		/**/"    end Empty\n" +
		/**/"   end ws\n" +
		/**/"   begin CHARACTER_TERMINAL ntA(65539) 'a'\n" +
		/**/"   end ntA\n" +
		/**/"  end Elt\n" +
		/**/" end List\n" +
		/**/" begin ALTERNATIVE ws(65538)\n" +
		/**/"  begin EMPTY Empty(65536)\n" +
		/**/"  end Empty\n" +
		/**/" end ws\n" +
		/**/"end Start\n";

		assertExpected(expected, result);
	}
}
