/*
 * Copyright 2008 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generateandparsetest.test;

import java.io.IOException;

import net.sf.parser4j.parser.entity.ParseResult;
import net.sf.parser4j.parser.service.HasAmbiguityParserException;
import net.sf.parser4j.parser.service.Parser;
import net.sf.parser4j.parser.service.ParserException;

/**
 * for token test
 * 
 * @author luc peuvrier
 * 
 */
public class Token1GrammarTest extends AbstractGrammarTest {

	public void test1TokenGrammar() throws ParserException,
			HasAmbiguityParserException, IOException {// NOPMD

		final Parser parser = createParser("token.xml");
		toHtml("runtime/token1.html");

		/*
		 * parsing of "ababax"
		 */
		final ParseResult result;
		try {
			result = parse(parser, false, false, "ababax");
		} catch (HasAmbiguityParserException exception) {
			try {
				parseNodeToXML.toXml("runtime/parsetree", exception,
						nonTerminalMap.getNonTerminalByIdentifierMap());
			} catch (Exception exception2) {
				_log.error("while output to xml ambiguity", exception2);
			}
			throw exception;
		}
		assertFalse("must have one result\n" + result, result.isInError());
		assertFalse("must not have alternative for ambiguity", parser
				.hasAlternativeForAmbiguity());

		final String expected =
		/**/"begin CONCAT Start(65543)\n" +
		/**/" begin ALTERNATIVE Ntab (token)(65540)\n" +
		/**/"  begin CONCAT Ntab2(65539)\n" +
		/**/"   begin ALTERNATIVE Ntab (token)(65540)\n" +
		/**/"    begin CONCAT Ntab1(65538)\n" +
		/**/"     begin CHARACTER_TERMINAL ta(65536) 'a'\n" +
		/**/"     end ta\n" +
		/**/"     begin CHARACTER_TERMINAL tb(65537) 'b'\n" +
		/**/"     end tb\n" +
		/**/"    end Ntab1\n" +
		/**/"   end Ntab (token)\n" +
		/**/"   begin CHARACTER_TERMINAL ta(65536) 'a'\n" +
		/**/"   end ta\n" +
		/**/"   begin CHARACTER_TERMINAL tb(65537) 'b'\n" +
		/**/"   end tb\n" +
		/**/"  end Ntab2\n" +
		/**/" end Ntab (token)\n" +
		/**/" begin CONCAT Ntax (token)(65542)\n" +
		/**/"  begin CHARACTER_TERMINAL ta(65536) 'a'\n" +
		/**/"  end ta\n" +
		/**/"  begin CHARACTER_TERMINAL tx(65541) 'x'\n" +
		/**/"  end tx\n" +
		/**/" end Ntax (token)\n" +
		/**/"end Start\n";

		assertExpected(expected, result);
	}
}
