/*
 * Copyright 2009 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generator.entity;

import java.io.File;
import java.io.UnsupportedEncodingException;

/**
 * to get file in this package
 * 
 * @author luc peuvrier
 * 
 */
public final class GeneratorOutputFile {

	private static final GeneratorOutputFile INSTANCE =
	/**/new GeneratorOutputFile();

	public static GeneratorOutputFile getInstance() {
		return INSTANCE;
	}

	private GeneratorOutputFile() {
		super();
	}

	public File createFile(final String fileName)
			throws UnsupportedEncodingException {
		final String path = "src-test/"
				+ getClass().getPackage().getName().replace('.', '/') + "/"
				+ fileName;
		return new File(path);
	}
}
