/*
 * Copyright 2009 Luc Peuvrier
 * 
 * This file is part of parser4j.
 *
 * parser4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * parser4j is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with parser4j.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.parser4j.generator.service;

import java.io.File;

import net.sf.parser4j.kernelgenerator.service.GeneratorException;
import net.sf.parser4j.parser.entity.ParseResult;
import net.sf.parser4j.parser.entity.data.ParserData;
import net.sf.parser4j.parser.service.ParserException;
import net.sf.parser4j.parserdata.ParserDataIOForTest;

/**
 * test generator with base txt grammar
 * 
 * @author luc peuvrier
 * 
 */
public class GeneratorWithBaseTxtTest extends AbstractGeneratorTest {// NOPMD

	private final static ParserDataIOForTest parserDataIOForTest =
	/**/ParserDataIOForTest.getInstance();

	protected ParseResult generate(final File inputFile, final File outFile)
			throws GeneratorException, ParserException {
		final ParserData parserData = parserDataIOForTest
				.readBaseTxtParserData();
		final ParseResult parseResult = parserDataGenerator.generate(
				parserData, inputFile, null/* htmlOutputFile */,
				null/* parserDataOutputFile */, ""/* matchMgrPackageName */,
				null/* grammarDefTreeTextFile */,
				outFile/* grammarTreeTextFile */, this);
		return parseResult;
	}

}
